namespace AirFighter
{
    public partial class FormAirFighter : Form
    {
        private DrawingAirFighter _airFighter;

        public FormAirFighter()
        {
            InitializeComponent();
        }
        
        private void SetData(DrawingAirFighter airFighter)
        {
            toolStripStatusLabelSpeed.Text = $": {_airFighter.AirFighter.Speed}";
            toolStripStatusLabelWeight.Text = $": {_airFighter.AirFighter.Weight}";
            toolStripStatusLabelBodyColor.Text = $": { _airFighter.AirFighter.BodyColor.Name}";
        }

        private void CreateButton_Click(object sender, EventArgs e)
        {
            Random rnd = new();

            _airFighter = new DrawingAirFighter(rnd.Next(100, 300), rnd.Next(1000, 2000), 
                             Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)));

            _airFighter.SetPosition(rnd.Next(10, 100), rnd.Next(10, 100), pictureBox.Width, pictureBox.Height);

            SetData(_airFighter);
            Draw();
        }

        private void CreateModernButton_Click(object sender, EventArgs e)
        {
            Random rnd = new();

            _airFighter = new DrawingModernAirFighter(rnd.Next(100, 300), rnd.Next(1000,2000), 
                Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0,256)), 
                Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0,256)),
                Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0,2)));


            _airFighter.SetPosition(rnd.Next(10, 100), rnd.Next(10, 100), pictureBox.Width, pictureBox.Height);

            SetData(_airFighter);
            Draw();
        }

        private void ButtonMove_Click(object sender, EventArgs e)
        {
            string name = ((Button)sender).Name ?? string.Empty;

            switch(name)
            {
                case "UpButton":
                    _airFighter?.MoveTransport(Direction.Up);
                    break;

                case "LeftButton":
                    _airFighter?.MoveTransport(Direction.Left);
                    break;

                case "DownButton":
                    _airFighter?.MoveTransport(Direction.Down);
                    break;

                case "RightButton":
                    _airFighter?.MoveTransport(Direction.Right);
                    break;
            }

            Draw();
        }

        private void PictureBox_Resize(object sender, EventArgs e)
        {
            _airFighter?.ChangeBorders(pictureBox.Width, pictureBox.Height);
            Draw();
        }


        public void Draw()
        {
            if (pictureBox.Width == 0 || pictureBox.Height == 0) return;
            Bitmap bmp = new(pictureBox.Width, pictureBox.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _airFighter?.DrawTransport(gr);
            pictureBox.Image = bmp;
        }
    }
}